#!/usr/bin/env python
# -*- coding: utf-8 -*-
'''
任务调度:
task_push(servie, arg, uuid=None, target=None), 新增加一个服务，后面是参数,比如
    task_push(fingerprint.www, 'http://www.baidu.com/')
    调度器会传递所有插件的audit函数(fingerprint.www, 'http://www.baidu.com/')这样的参数
    如果指定UUID，UUID将做为此任务的唯一标识，防止重复，如果不指定，系统将自动生成一个UUID
    如果指定target参数，新生的任务产生的报告所属的域名为target指定的值

报告函数:
通知: security_note(str)
提示: security_info(str)
警告: security_warning(url,log=log)
漏洞: security_hole(url,log=log)

hackhttp:
    示例：
    GET:
        hackhttp.http('http://www.example.com/')
    POST:
        hackhttp.http('http://www.example.com/',post='some data')
    raw:
        hackhttp.http('http://www.example.com/',raw=raw_data)
        
    header:
        hackhttp.http('http://www.example.com/',headers={'Referer':'url','Cookie':'ssid=123123'})
        hackhttp.http('http://www.example.com/',header='Referer: http://www.example.com/redirect')
        
    user_agent/referer/cookie:
        hackhttp.http('http://www.example.com/',user_agent='Chrome')
        hackhttp.http('http://www.example.com/',referer='http://www.example.com/redirect')
        

util:
    is_ipaddr(str)  字串是否一个IP地址
    decode_html(head, body) 根据HTTP头和内容进行编码转换成utf-8编码
    urljoin(base, ref) URL组合，比如urljoin('http://www.baidu.com/', 'abc/../dd.html') 将返回http://www.baidu.com/dd.html
    html2text(body, head='') HTML转换为txt,如果指定head,尝试用decode_html解码后转换
    get_url_host(url) 得到URL域名，因为太经常用了，附带写上
    get_domain_root(url) 得到一个URL或者域名的根域名(内置TLD字典)
    str_ration(str1, str2)  比较两个文本的相似度，会根据长度自动选择最快匹配算法

'''

if __name__ == '__main__':
    from dummy import *
    code, head, body, final_url,log = hackhttp.http('http://www.baidu.com/')

    print util.is_ipaddr('8.8.8.8')
    print util.decode_html(head, body)
    print util.urljoin('http://www.baidu.com/', 'abc/../dd.html')
    print util.html2text(body)
    print util.get_domain_root("www.baidu.com.cn")
    print util.get_domain_root("http://bbs.sina.com.tw")
    print util.str_ratio("good", "not good")
    task_push(fingerprint.www, 'http://www.baidu.com/')

